'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

var _getFunctionParams = require('./utils/getFunctionParams');

var _getFunctionParams2 = _interopRequireDefault(_getFunctionParams);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ArrowFunctionExpression = function (_Expression) {
    (0, _inherits3.default)(ArrowFunctionExpression, _Expression);

    function ArrowFunctionExpression(childNodes) {
        (0, _classCallCheck3.default)(this, ArrowFunctionExpression);

        var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(ArrowFunctionExpression).call(this, 'ArrowFunctionExpression', childNodes));

        _this.id = null;
        _this.generator = false;
        _this.isFunction = true;
        return _this;
    }

    (0, _createClass3.default)(ArrowFunctionExpression, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var params = [];
            var async = false;

            if (children.isToken('Identifier', 'async')) {
                async = true;
                children.passToken('Identifier', 'async');
                children.skipNonCode();
            }

            if (children.isToken('Punctuator', '(')) {
                params = (0, _getFunctionParams2.default)(children);
                children.skipNonCode();
            } else if (children.currentElement.isPattern) {
                params.push(children.currentElement);
                children.moveNext();
                children.skipNonCode();
            }

            children.passToken('Punctuator', '=>');
            children.skipNonCode();

            var expression = !children.currentElement.isStatement;

            var body = void 0;
            if (expression) {
                body = children.passExpression();
            } else {
                body = children.passStatement();
            }

            children.assertEnd();

            this.async = async;
            this.params = params;
            this.body = body;
            this.expression = expression;
        }
    }]);
    return ArrowFunctionExpression;
}(_Expression3.default);

exports.default = ArrowFunctionExpression;