'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var assignmentOperators = {
    '=': true,
    '+=': true,
    '-=': true,
    '*=': true,
    '/=': true,
    '%=': true,
    '<<=': true,
    '>>=': true,
    '>>>=': true,
    '|=': true,
    '^=': true,
    '&=': true,
    '**=': true
};

var AssignmentExpression = function (_Expression) {
    (0, _inherits3.default)(AssignmentExpression, _Expression);

    function AssignmentExpression(childNodes) {
        (0, _classCallCheck3.default)(this, AssignmentExpression);
        return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(AssignmentExpression).call(this, 'AssignmentExpression', childNodes));
    }

    (0, _createClass3.default)(AssignmentExpression, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var left = children.passAssignable();
            children.skipNonCode();
            children.assertToken('Punctuator', assignmentOperators);
            var operator = children.currentElement.value;
            children.moveNext();
            children.skipNonCode();
            var right = children.passExpression();
            children.assertEnd();

            this.left = left;
            this.operator = operator;
            this.right = right;
        }
    }]);
    return AssignmentExpression;
}(_Expression3.default);

exports.default = AssignmentExpression;