'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TemplateLiteral = function (_Expression) {
    (0, _inherits3.default)(TemplateLiteral, _Expression);

    function TemplateLiteral(childNodes) {
        (0, _classCallCheck3.default)(this, TemplateLiteral);
        return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(TemplateLiteral).call(this, 'TemplateLiteral', childNodes));
    }

    (0, _createClass3.default)(TemplateLiteral, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var quasis = [];
            var expressions = [];

            children.passToken('Punctuator', '`');
            while (!children.isToken('Punctuator', '`')) {
                if (children.isNode('TemplateElement')) {
                    quasis.push(children.passNode('TemplateElement'));
                } else {
                    children.passToken('Punctuator', '${');
                    children.skipNonCode();
                    expressions.push(children.passExpression());
                    children.skipNonCode();
                    children.passToken('Punctuator', '}');
                }
            }
            children.passToken('Punctuator', '`');

            if (quasis.length > 0) {
                quasis[quasis.length - 1].tail = true;
            }

            this.quasis = quasis;
            this.expressions = expressions;
        }
    }]);
    return TemplateLiteral;
}(_Expression3.default);

exports.default = TemplateLiteral;