'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _BasePlugin2 = require('../BasePlugin');

var _BasePlugin3 = _interopRequireDefault(_BasePlugin2);

var _ScopesApi = require('./ScopesApi');

var _ScopesApi2 = _interopRequireDefault(_ScopesApi);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ScopesPlugin = function (_BasePlugin) {
    (0, _inherits3.default)(ScopesPlugin, _BasePlugin);

    function ScopesPlugin() {
        (0, _classCallCheck3.default)(this, ScopesPlugin);
        return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(ScopesPlugin).apply(this, arguments));
    }

    (0, _createClass3.default)(ScopesPlugin, [{
        key: 'getPluginName',
        value: function getPluginName() {
            return 'scopes';
        }
    }, {
        key: 'createApiForProgram',
        value: function createApiForProgram(program) {
            return new _ScopesApi2.default(program);
        }
    }]);
    return ScopesPlugin;
}(_BasePlugin3.default);

exports.default = ScopesPlugin;